#ifndef BOARD_H
#define BOARD_H

#define possible_number(bb, xx, yy) \
(~((bb)->x[(xx)] | (bb)->y[(yy)] | (bb)->b[(bb)->i[(yy)][(xx)]]) & 0x1ff);

typedef struct {
	unsigned int x[9], y[9], b[9];
	int i[9][9], j[9][9];
	unsigned int n[9][9];
	int count, sol;
} Board;

void initialize_board(Board *);
void zero_board(Board *);
void clear_number(Board *);
int bit2int(unsigned int);
int count_possible_numbers(Board *, int, int);

void put(Board *, int, int, unsigned int);
void rm(Board *, int, int);

int remove_number(Board *, int, int);
int put_number(Board *, int, int, int);

void next(Board *, int, int);

int search(Board *, int, int);
int search_minimum_choice(Board *, int *, int *);

#endif /* BOARD_H */
