#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <time.h>

#include "board.h"
#include "gen.h"
#include "random.h"
#include "region.h"
#include "print.h"

int main(void)
{
	const static Board zero;
	Board b;
	int i;
	clock_t sec;
	double gen = 0, scn = 0, sol = 0;
	double gen_sum = 0, scn_sum = 0, sol_sum = 0;
	const int cycle = 10;
	
	init_rand();
	for (i = 0; i < cycle; i ++) {
		change_seed();
		b = zero;
		
		sec = clock();
		generate_region(&b, 1, 1);
		print_board(&b);
		generate(&b, -1, 0);
		print_board(&b);
		gen = (double) (clock() - sec) / CLOCKS_PER_SEC;
		printf("generate %3.2f\t", gen);
		gen_sum += gen;
		
		sec = clock();
		random_scan_rm(&b);
		scn = (double) (clock() - sec) / CLOCKS_PER_SEC;
		printf("scan %2d : %3.2f\t", b.count, scn);
		scn_sum += scn;
		
		b.sol = 0;
		
		sec = clock();
		search(&b, -1, 0);
		sol = (double) (clock() - sec) / CLOCKS_PER_SEC;
		printf("solve %d : %3.2f\n", b.sol, sol);
		sol_sum += sol;

//		if (scn > 10) {
			print_board(&b);
//		}
		
		assert(b.sol == 1);
	}
	printf("%f : %f : %f\n", gen_sum, scn_sum, sol_sum);
	printf("%f : %f : %f\n", gen_sum / cycle, scn_sum / cycle, sol_sum / cycle);
//	print_board(&b);
	return 0;
}
