#include <assert.h>
#include <windows.h>
#include <tchar.h>

#include "board.h"
#include "mark.h"
#include "util.h"

unsigned int g_mark[9][9];

void mark_clear_all(void)
{
	int x, y;
	
	for (y = 0; y < 9; y ++) {
		for (x = 0; x < 9; x ++) {
			g_mark[y][x] = 0;
		}
	}
}

void mark_all(Board *b)
{
	int x, y;
	
	for (y = 0; y < 9; y ++) {
		for (x = 0; x < 9; x ++) {
			g_mark[y][x] = ~(b->x[x] | b->y[y] | b->b[b->i[y][x]]) & 0x1ff;
		}
	}
}

void mark_clear(int x, int y)
{
	g_mark[y][x] = 0;
}

void mark_toggle(int x, int y, int n)
{
	if (n >= 1 && n <= 9) {
		g_mark[y][x] ^= 0x1 << (n - 1);
	} else {
		g_mark[y][x] = 0;
	}
}

void mark2code(LPTSTR code)
{
	int x, y;
	
	for (y = 0; y < 9; y ++) {
		for (x = 0; x < 9; x ++) {
			wsprintf(code, _T("%03X"), g_mark[y][x]);
			code += 3;
		}
	}
	*code = _T('\0');
}

BOOL code2mark(LPTSTR code)
{
	int x, y, i, j;
	unsigned int n;
	
	if (! code) return FALSE;
	for (y = 0; y < 9; y ++) {
		for (x = 0; x < 9; x ++) {
			n = 0;
			for (i = 0, j = 8; i < 3; i ++, j -= 4, code ++) {
				if (*code >= _T('0') && *code <= _T('9')) {
					n |= (*code - _T('0')) << j;
				} else if (*code >= _T('A') && *code <= _T('F')) {
					n |= (*code - _T('A') + 10) << j;
				} else {
					return FALSE;
				}
			}
			g_mark[y][x] = n;
		}
	}
	return TRUE;
}
