#include <stdio.h>
#include "board.h"

void print_board(Board *b)
{
	static const char n[] = {
		'.', '1', '2', '3', '4', '5', '6', '7', '8', '9'
	};
	static const char p[] = {
		' ', '+', '+', '+', '+', '+', '-', '+',
		'+', '|', '+', '+', '+', '+', '+', '+'
	};
	int x, y, v;
	
	printf("+---"); 
	for (x = 0; x < 8; x ++) {
		printf("%c---", (b->i[0][x] == b->i[0][x + 1]) ? '-' : '+'); 
	}
	puts("+"); 
	for (y = 0; y < 9; y ++) {
		putchar('|');
		for (x = 0; x < 8; x ++) {
			printf(" %c ", n[bit2int(b->n[y][x])]);
			if (b->i[y][x] == b->i[y][x + 1]) {
				putchar(' ');
			} else {
				putchar('|');
			}
		}
		printf(" %c ", n[bit2int(b->n[y][x])]);
		puts("|");
		putchar((y < 8 && b->i[y][0] == b->i[y + 1][0]) ? '|' : '+');
		for (x = 0; x < 8; x ++) {
			if (y < 8 && b->i[y][x] == b->i[y + 1][x]) {
				printf("   ");
			} else {
				printf("---");
			}
			v = 0;
			v |= (b->i[y][x] != b->i[y][x + 1]) ? 0x1 : 0;
			if (y < 8) {
				v |= (b->i[y][x] != b->i[y + 1][x]) ? 0x2 : 0;
				v |= (b->i[y][x + 1] != b->i[y + 1][x + 1]) ? 0x4 : 0;
				v |= (b->i[y + 1][x] != b->i[y + 1][x + 1]) ? 0x8 : 0;
			} else {
				v |= 0x6;
			}
			putchar(p[v]);
		}
		if (y < 8 && b->i[y][x] == b->i[y + 1][x]) {
			puts("   |");
		} else {
			puts("---+");
		}
	}
}
