#include "random.h"

#if 1

/* Wichmann-Hill */

#include <stdlib.h>
#include <time.h>

static int ix = 1, iy = 1, iz = 1;

static void init_rnd(int x, int y, int z)
{
	ix = x; iy = y; iz = z;
}

static double rnd(void)
{
	double r;
	
	ix = (int)((171 * ix) % 30269);
	iy = (int)((172 * iy) % 30307);
	iz = (int)((170 * iz) % 30323);
	r = ix / 30269.0 + iy / 30307.0 + iz / 30323.0;
	while (r >= 1) r --;
	return r;
}


#define SEEDREUSE   293

static int g_generate_count;

void init_rand(void)
{
}

unsigned int range_rand(unsigned int max)
{
	return rnd() * max;
}

void change_seed(void)
{
	if (g_generate_count == 0) {
		srand(time(NULL));
		init_rnd(rand() % 30000 + 1, rand() % 30000 + 1, rand() % 30000 + 1);
	}
	g_generate_count = (g_generate_count + 1) % SEEDREUSE;
}

#else

/* rand */

#include <stdlib.h>
#include <time.h>

#define SEEDREUSE   101

static int g_generate_count;

void init_rand(void)
{
}

unsigned int range_rand(unsigned int max)
{
	return rand() / ((RAND_MAX + max) / max);
}

void change_seed(void)
{
	if (g_generate_count == 0) {
		srand(time(NULL));
	}
	g_generate_count = (g_generate_count + 1) % SEEDREUSE;
}

#endif
